Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs	(revision 16626)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/SymbolicRegressionSolution.cs	(revision 16627)
@@ -29,4 +29,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.DataAnalysis.Implementation;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Regression {
@@ -34,5 +35,5 @@
   /// Represents a symbolic regression solution (model + data) and attributes of the solution like accuracy and complexity
   /// </summary>
-  [StorableClass]
+  [StorableType("CC27F20C-5925-406B-9C38-3C4B2B781C9F")]
   [Item(Name = "SymbolicRegressionSolution", Description = "Represents a symbolic regression solution (model + data) and attributes of the solution like accuracy and complexity.")]
   public sealed class SymbolicRegressionSolution : RegressionSolution, ISymbolicRegressionSolution {
@@ -101,11 +102,14 @@
     }
 
-    private NamedIntervals IntervalEvaluaitonCollection => 
-      (NamedIntervals) this[IntervalEvaluationResultName].Value;
+
+    public NamedIntervals IntervalEvaluationCollection {
+      get { return (NamedIntervals)this[IntervalEvaluationResultName].Value; }
+      private set { this[IntervalEvaluationResultName].Value = value; }
+    }
 
 
 
     [StorableConstructor]
-    private SymbolicRegressionSolution(bool deserializing) : base(deserializing) { }
+    private SymbolicRegressionSolution(StorableConstructorFlag _) : base(_) { }
     private SymbolicRegressionSolution(SymbolicRegressionSolution original, Cloner cloner)
       : base(original, cloner) {
@@ -130,7 +134,6 @@
       RecalculateResults();
 
-      var namedIntervalCollection = new NamedIntervals();
-      Add(new Result(IntervalEvaluationResultName, "Results concerning the derivation of symbolic regression solution", namedIntervalCollection));
-      GetIntervalEvaulations(namedIntervalCollection);
+      Add(new Result(IntervalEvaluationResultName, "Results concerning the derivation of symbolic regression solution", GetIntervalEvaluations()));
+      ;
     }
 
@@ -152,8 +155,4 @@
         Add(new Result(EstimationLimitsResultsResultName, "Results concerning the estimation limits of symbolic regression solution", estimationLimitResults));
         CalculateResults();
-
-        var namedIntervalCollection = new NamedIntervals();
-        Add(new Result(IntervalEvaluationResultName, "Results concerning the derivation of symbolic regression solution", namedIntervalCollection));
-        GetIntervalEvaulations(namedIntervalCollection);
       }
     }
@@ -164,5 +163,6 @@
     }
 
-    private void GetIntervalEvaulations(NamedIntervals intervalEvaluation) {
+    private NamedIntervals GetIntervalEvaluations() {
+      var intervalEvaluation = new NamedIntervals();
       var interpreter = new IntervalInterpreter();
       var variableRanges = (ProblemData as RegressionProblemData)?.VariableRangesParameter.Value.VariableIntervals;
@@ -181,4 +181,5 @@
         }
       }
+      return intervalEvaluation;
     }
     
@@ -196,4 +197,6 @@
       TrainingNaNEvaluations = Model.Interpreter.GetSymbolicExpressionTreeValues(Model.SymbolicExpressionTree, ProblemData.Dataset, ProblemData.TrainingIndices).Count(double.IsNaN);
       TestNaNEvaluations = Model.Interpreter.GetSymbolicExpressionTreeValues(Model.SymbolicExpressionTree, ProblemData.Dataset, ProblemData.TestIndices).Count(double.IsNaN);
+
+      IntervalEvaluationCollection = GetIntervalEvaluations();
     }
   }
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/NamedIntervalsView.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/NamedIntervalsView.cs	(revision 16626)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/NamedIntervalsView.cs	(revision 16627)
@@ -47,5 +47,4 @@
     public NamedIntervalsView() {
       InitializeComponent();
-      setColumnNames();
       dataGridView.AutoGenerateColumns = false;
       dataGridView.AllowUserToAddRows = false;
@@ -69,4 +68,9 @@
 
     protected void UpdateData() {
+      DataGridView.Rows.Clear();
+      DataGridView.Columns.Clear();
+      SetColumnNames();
+
+
       var variablesCount = Content.VariableIntervals.Count;
 
@@ -102,5 +106,5 @@
     }
 
-    protected void setColumnNames() {
+    protected void SetColumnNames() {
       dataGridView.Columns.Add("lowerBound", "Lower Bound");
       dataGridView.Columns.Add("upperBound", "Upper Bound");